(*
    ============================================================================
    [2004/04/05]    TFormCustomizer
    [2004/04/03]    TMessageBox
    ============================================================================
*)

//------------------------------------------------------------------------------
unit fjutil;
//------------------------------------------------------------------------------
interface
//------------------------------------------------------------------------------
uses
    Windows, SysUtils, Forms, IniFiles, ShellAPI, ShlObj, ActiveX, ComObj;

//------------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------
type
    TWinApi = class
    public
        function    IsKeyDown(const K: Word): Boolean;
        function    GetTempFile(const Extension: string): string;      overload;
        function    GetTempFile(const Dir, Extension: string): string; overload;
        function    FileSize(const Path: string): integer;
        function    MoveFile(const Src, Dst: string): Boolean;
    end;

//------------------------------------------------------------------------------
//  VFn̂₱z
//------------------------------------------------------------------------------
type
    TClassID =
    (
        idDesktop    = CSIDL_DESKTOP,          //  fXNgbv
        idDesktopDir = CSIDL_DESKTOPDIRECTORY, //  fXNgbv
        idPersonal   = CSIDL_PERSONAL,         //  }ChLg
        idCookies    = CSIDL_COOKIES,          //  NbL[
        idFavorites  = CSIDL_FAVORITES,        //  Cɓ
        idFonts      = CSIDL_FONTS,            //  tHg
        idHistory    = CSIDL_HISTORY,          //  
        idCache      = CSIDL_INTERNET_CACHE,   //  C^[lbg̃LbV
        idPrograms   = CSIDL_PROGRAMS,         //  vO
        idRecent     = CSIDL_RECENT,           //  ŋߎgt@C
        idSendTo     = CSIDL_SENDTO,           //  
        idStartMenu  = CSIDL_STARTMENU,        //  X^[gj[
        idStartup    = CSIDL_STARTUP,          //  X^[gAbv
        idTemplates  = CSIDL_TEMPLATES         //  ev[g
    );

    TPoorShell = class
    public
        function    GetSpecialFolder(const nFolder: TClassID): string;
        function    CreateShortCut(const FileName, Args, WorkDir, DestPath: string): Boolean;
        function    ShellExecute(const FileName, Params: string): Boolean;
    end;

//------------------------------------------------------------------------------
//  tH[ƂNX
//------------------------------------------------------------------------------
type
    TFormCustomizer = class
    private
        FIni        : TIniFile;
        FIniName    : string;
    public
        constructor Create();
        //  LvVȂ
        procedure   SetCaption(F: TForm);
        //  ʒuINIt@CǍ
        procedure   LoadPosFromIni(F: TForm);
        //  ʒuINIt@Cɕۑ                 
        procedure   SavePosToIni(F: TForm);
    end;

//------------------------------------------------------------------------------
//  bZ[W{bNX\pNX
//  TApplication.MessageBox()  Flag G炸 Windows.MessageBox ɓnƂ
//  OƂƗEڐA̔؂Ȏ
//------------------------------------------------------------------------------
type
    TMessageBox = class
    private
        function    _MessageBox(const S: string; const F: integer): integer;
        function    _MessageBoxEx(const S: string; const F: integer;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
    public
        //  Information{bNX
        procedure   InfoOk(const S: string; const IsSysTop: Boolean = false);
        //  Warning{bNX
        procedure   WarnOk(const S: string; const IsSysTop: Boolean = false);
        //  Error{bNX
        procedure   ErrorOk(const S: string; const IsSysTop: Boolean = false);
        //  Ok/Cancel{bNX
        function    OkCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
        //  Yes/No{bNX
        function    YesNo(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
        //  Yes/No/Cancel{bNX
        function    YesNoCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
    end;

//------------------------------------------------------------------------------
var
    WinApi: TWinApi;
    PShell: TPoorShell;
    FBox: TFormCustomizer;
    MBox: TMessageBox;
//------------------------------------------------------------------------------

implementation

(*
    ============================================================================
    TWinApi
    ============================================================================
*)

//------------------------------------------------------------------------------
//  t@Cړ
function    TWinApi.MoveFile(const Src, Dst: string): Boolean;
begin
    Result := Windows.MoveFile(PChar(Src), PChar(Dst));
end;

(*
    ============================================================================
    http://www.wwlnk.com/boheme/delphi/tips/tec0060.htm
    ----------------------------------------------------------------------------
    [2004/04/06]t@CTCY擾
    ============================================================================
*)
function    TWinApi.FileSize(const Path: string): integer;
var
    Rec: TSearchRec;
begin
    Result := 0;
    if  FindFirst(Path, faAnyFile, Rec) = 0 then
    begin
        Result :=  Rec.Size;
    end;
    FindClose(Rec);
end;

(*
    ============================================================================
    http://www.mesuttop.com/delphi/tip_files.htm
    ----------------------------------------------------------------------------
    [2004/04/06]Using GetTempFileName to create a unique temporary file
    ============================================================================
*)
function    TWinApi.GetTempFile(const Extension: string): string;
var
    Buffer: array[0..MAX_PATH] of char;
begin
    GetTempPath(Sizeof(Buffer) - 1, Buffer);
    GetTempFileName(Buffer, PChar(Extension), 0, Buffer);
    Result := String(Buffer);
end;

function    TWinApi.GetTempFile(const Dir, Extension: string): string;
var
    Buffer: array[0..MAX_PATH] of char;
begin
    GetTempFileName(PChar(Dir), PChar(Extension), 0, Buffer);
    Result := String(Buffer);
end;
(*
    ============================================================================
    http://forum.nifty.com/fdelphi/samples/00782.html
    ----------------------------------------------------------------------------
    [2004/04/06]"ESCL[Ń[vf"
    ============================================================================
*)
function    TWinApi.IsKeyDown(const K: Word): Boolean;
begin
    Result := (GetAsyncKeyState(K) <> 0);
end;

(*
    ============================================================================
    TPoorShell
    ============================================================================
*)

//------------------------------------------------------------------------------
//  ShellExecute
function    TPoorShell.ShellExecute(const FileName, Params: string): Boolean;
const
    ERROR_NO = 32;
var
    Value: integer;
begin
    Value := ShellApi.ShellExecute(0, 'open', PChar(FileName), PChar(Params), nil, SW_SHOWDEFAULT);
    Result := (Value > ERROR_NO);
end;

(*
    ============================================================================
    http://i749.obi.ne.jp/kazina/html/memo/delphi/getspecialfolder.html
    ----------------------------------------------------------------------------
    [2004/04/05]VXetH_擾
    ============================================================================
*)
function    TPoorShell.GetSpecialFolder(const nFolder: TClassID): string;
var
    pidl: PItemIDList;
    Buffer: array[0..MAX_PATH] of Char;
begin
    SHGetSpecialFolderLocation(0, Ord(nFolder), pidl);
    SHGetPathFromIDList(pidl, Buffer);
    Result := Buffer;
end;

(*
    ============================================================================
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink
    ----------------------------------------------------------------------------
    [2004/04/05]X^[gAbvɃV[gJbg쐬
    ============================================================================
*)
function    TPoorShell.CreateShortCut(const FileName, Args, WorkDir, DestPath: string): Boolean;
var
    ShellLink: IShellLink;
    PersistFile: IPersistFile;
    LinkFileName: string;
    WFileName: WideString;
begin
    //  V[gJbgpCOMIuWFNg쐬
    ShellLink:= CreateComObject(CLSID_ShellLink) as IShellLink;
    //  V[gJbgt@CpIuWFNg
    PersistFile:= ShellLink as IPersistFile;
    //  ݒ
    with ShellLink do
    begin
        //  t@ČɎw肷p[^(prs)
        SetArguments(PChar(Args));
        //  Nt@C̃tpX
        SetPath(PChar(FileName));
        //  ƃtH_
        SetWorkingDirectory(PChar(WorkDir));
    end;
    //  V[gJbgt@C̃pX
    LinkFileName := ChangeFileExt(ExtractFilename(FileName),'.lnk'); 
    LinkFileName := Format('%s\%s', [DestPath, LinkFileName]);
    WFileName := WideString(LinkFileName);
    //  t@C쐬
    OleCheck(PersistFile.Save(PWChar(WFileName), false));
    //  ǂłH
    Result := FileExists(LinkFileName);
end;

(*
    ============================================================================
    TFormCustomizer
    ============================================================================
*)

//------------------------------------------------------------------------------
constructor TFormCustomizer.Create();
begin
    FIniName := ChangeFileExt(ParamStr(0), '.ini');
end;

//------------------------------------------------------------------------------
procedure   TFormCustomizer.LoadPosFromIni(F: TForm);
begin
    FIni := TIniFile.Create(FIniName);
    try
        F.Left   := FIni.ReadInteger(F.Name, 'Left', F.Left);
        F.Top    := FIni.ReadInteger(F.Name, 'Top', F.Top);
        F.Width  := FIni.ReadInteger(F.Name, 'Width', F.Width);
        F.Height := FIni.ReadInteger(F.Name, 'Height', F.Height);
    finally
        FIni.Free;
    end;
end;

//------------------------------------------------------------------------------
procedure   TFormCustomizer.SavePosToIni(F: TForm);
begin
    FIni := TIniFile.Create(FIniName);
    try
        FIni.WriteInteger(F.Name, 'Left', F.Left);
        FIni.WriteInteger(F.Name, 'Top', F.Top);
        FIni.WriteInteger(F.Name, 'Width', F.Width);
        FIni.WriteInteger(F.Name, 'Height', F.Height);
    finally
        FIni.Free;
    end;
end;

//------------------------------------------------------------------------------
procedure   TFormCustomizer.SetCaption(F: TForm);
begin
    F.Caption := Format('%s - %s', [ChangeFileExt(ExtractFileName(ParamStr(0)), ''), F.Caption]);
end;

(*
    ============================================================================
    TMessageBox
    ============================================================================
*)

//------------------------------------------------------------------------------
function    TMessageBox._MessageBox(const S: string; const F: integer): integer;
begin
    Application.BringToFront();
    Result := Application.MessageBox(PChar(S), PChar(Application.Title), F);
end;
//------------------------------------------------------------------------------
function    TMessageBox._MessageBoxEx(const S: string; const F: integer;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var _F: integer;
begin
    _F := F;
    if IsSysTop then _F := _F + MB_TOPMOST;
    case DefBtnNo of
    2: _F := _F + MB_DEFBUTTON2;
    3: _F := _F + MB_DEFBUTTON3;
    4: _F := _F + MB_DEFBUTTON4;
    end;
    Result := _MessageBox(S, _F);
end;
//------------------------------------------------------------------------------
procedure   TMessageBox.InfoOk(const S: string;const IsSysTop: Boolean = false);
var F: integer;
begin
    F := MB_OK + MB_ICONINFORMATION;
    _MessageBoxEx(S, F, 1, IsSysTop);
end;
//------------------------------------------------------------------------------
procedure   TMessageBox.WarnOk(const S: string; const IsSysTop: Boolean = false);
var F: integer;
begin
    F := MB_OK + MB_ICONWARNING;
    _MessageBoxEx(S, F, 1, IsSysTop);
end;
//------------------------------------------------------------------------------
procedure   TMessageBox.ErrorOk(const S: string; const IsSysTop: Boolean = false);
var F: integer;
begin
    F := MB_OK + MB_ICONERROR;
    _MessageBoxEx(S, F, 1, IsSysTop);
end;
//------------------------------------------------------------------------------
function    TMessageBox.OkCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var F: integer;
begin
    F := MB_OKCANCEL + MB_ICONQUESTION;
    Result := _MessageBoxEx(S, F DefBtnNo, IsSysTop,);
end;
//------------------------------------------------------------------------------
function    TMessageBox.YesNo(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var F: integer;
begin
    F := MB_YESNO + MB_ICONQUESTION;
    Result := _MessageBoxEx(S, F DefBtnNo, IsSysTop,);
end;
//------------------------------------------------------------------------------
function    TMessageBox.YesNoCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var F: integer;
begin
    F := MB_YESNOCANCEL + MB_ICONQUESTION;
    Result := _MessageBoxEx(S, F DefBtnNo, IsSysTop,);
end;
//------------------------------------------------------------------------------
initialization
    WinApi := TWinApi.Create;
    PShell := TPoorShell.Create;
    FBox := TFormCustomizer.Create;
    MBox := TMessageBox.Create;
finalization
    WinApi.Free;
    PShell.Free;
    FBox.Free;
    MBox.Free;
//------------------------------------------------------------------------------
end.

